package com.supwisdom.dlpay.consume

import com.supwisdom.dlpay.consume.domain.TAccount
import com.supwisdom.dlpay.consume.domain.TPaydtl
import com.supwisdom.dlpay.consume.domain.TPerson
import com.supwisdom.dlpay.consume.service.PersonBalancePayService

class PersonBalancePayBuilder private constructor() {
    companion object {
        fun newBuilder() = PersonBalancePayBuilder()
    }

    lateinit var person: TPerson
    lateinit var account: TAccount

    var transDate = ""
    var transTime = ""
    var description = ""
    val details = mutableListOf<PayDtlBuilder.PayDetail>()

    fun setUserAndAcc(per: TPerson, acc: TAccount) {
        this.person = per
        this.account = acc
    }

    private fun prepareData() {

    }

    private fun preCheckAccount() {

    }

    /**
     * 单步交易，一次完成交易记账过程
     * @param service
     * @param isFinished - true : 完成交易过程,扣除账户余额; false - 完成检查
     */
    fun done(service: PersonBalancePayService, isFinished: Boolean): TPaydtl {
        prepareData()
        preCheckAccount()
        return service.process(this)
    }

    /**
     * 两步交易，在 paydtl 基础完成确认过程
     * @param paydtl
     * @param status - 完成交易状态，见 TradeDict.DTL_STATUS_FAIL
     */
    fun done(paydtl: TPaydtl, status: String, service: PersonBalancePayService): TPaydtl {
        TODO("finish")
    }

    fun done(refno: String, status: String, service: PersonBalancePayService): TPaydtl {
        TODO("add process")
    }
}