package com.supwisdom.dlpay.consume.service

import com.supwisdom.dlpay.consume.PersonBalancePayBuilder
import com.supwisdom.dlpay.consume.domain.TPaydtl

interface PersonBalancePayService {

    /**
     * 一步完成交易
     */
    fun process(builder: PersonBalancePayBuilder): TPaydtl

    /**
     * 两步交易，交易初始化方法，检查交易参数，记录交易流水
     */
    fun init(builder: PersonBalancePayBuilder): TPaydtl

    /**
     * 两步交易，交易过程中判断交易状态，并更新交易状态为 wip
     */
    fun wip(paydtl: TPaydtl, builder: PersonBalancePayBuilder): TPaydtl

    fun wip(refno: String, builder: PersonBalancePayBuilder): TPaydtl

    /**
     * 两步交易，完成交易过程，包括更新交易状态（成功、失败），更新借贷双方余额
     */
    fun finish(paydtl: TPaydtl, status: String, builder: PersonBalancePayBuilder): TPaydtl

    fun finish(refno: String, status: String, builder: PersonBalancePayBuilder): TPaydtl
}